ext4: add treeid quota support

Implement directory tree quota support.
- Quota transfer performed in EXT4_IOC_SET_TREEID
STATUS: Seems to work, more testing is needed.
note: Journalled quota is broken for now due to incorrect block reservation.

diff --git a/fs/ext4/ext4.h b/fs/ext4/ext4.h
index bd76c0f..615c622 100644
--- a/fs/ext4/ext4.h
+++ b/fs/ext4/ext4.h
@@ -756,6 +756,7 @@ struct ext4_inode_info {
 #define EXT4_MOUNT_DATA_ERR_ABORT	0x10000000 /* Abort on file data write */
 #define EXT4_MOUNT_BLOCK_VALIDITY	0x20000000 /* Block validity checking */
 #define EXT4_MOUNT_TREEID		0x40000000 /* Dirtectory tree id */
+#define EXT4_MOUNT_TRQUOTA		0x80000000 /* Dir tree quota support */
 
 #define clear_opt(o, opt)		o &= ~EXT4_MOUNT_##opt
 #define set_opt(o, opt)			o |= EXT4_MOUNT_##opt
diff --git a/fs/ext4/ioctl.c b/fs/ext4/ioctl.c
index bf6b500..a5387a4 100644
--- a/fs/ext4/ioctl.c
+++ b/fs/ext4/ioctl.c
@@ -185,6 +185,7 @@ setversion_out:
 		int err;
 		struct ext4_iloc iloc;
 		unsigned int treeid;
+		qid_t new[MAXQUOTAS];
 		handle_t *handle = NULL;
 		struct inode *dir = IS_ROOT(filp->f_dentry) ?
 			NULL : filp->f_dentry->d_parent->d_inode;
@@ -247,7 +248,12 @@ setversion_out:
 		if (err)
 			goto settree_err;
 
-		////FIXME: tree quota transfer here
+		new[TRQUOTA] = treeid;
+		err = inode->i_sb->dq_op->transfer(inode, new, 1 << TRQUOTA);
+		if (err == NO_QUOTA) {
+			err = -EDQUOT;
+			goto settree_err;
+		}
 		ei->i_tree_id = treeid;
 		inode->i_mtime = ext4_current_time(inode);
 		err = ext4_mark_iloc_dirty(handle, inode, &iloc);
diff --git a/fs/ext4/super.c b/fs/ext4/super.c
index 6b9e4f3..d5c26d9 100644
--- a/fs/ext4/super.c
+++ b/fs/ext4/super.c
@@ -784,11 +784,17 @@ static inline void ext4_show_quota_options(struct seq_file *seq,
 	if (sbi->s_qf_names[GRPQUOTA])
 		seq_printf(seq, ",grpjquota=%s", sbi->s_qf_names[GRPQUOTA]);
 
+	if (sbi->s_qf_names[TRQUOTA])
+		seq_printf(seq, ",trjquota=%s", sbi->s_qf_names[TRQUOTA]);
+
 	if (test_opt(sb, USRQUOTA))
 		seq_puts(seq, ",usrquota");
 
 	if (test_opt(sb, GRPQUOTA))
 		seq_puts(seq, ",grpquota");
+
+	if (test_opt(sb, TRQUOTA))
+		seq_puts(seq, ",trquota");
 #endif
 }
 
@@ -999,7 +1005,7 @@ static ssize_t ext4_quota_read(struct super_block *sb, int type, char *data,
 			       size_t len, loff_t off);
 static ssize_t ext4_quota_write(struct super_block *sb, int type,
 				const char *data, size_t len, loff_t off);
-
+static qid_t ext4_get_quotid(struct inode *inode, int type);
 static const struct dquot_operations ext4_quota_operations = {
 	.initialize	= dquot_initialize,
 	.drop		= dquot_drop,
@@ -1012,7 +1018,7 @@ static const struct dquot_operations ext4_quota_operations = {
 	.free_space	= dquot_free_space,
 	.free_inode	= dquot_free_inode,
 	.transfer	= dquot_transfer,
-	.get_id		= dquot_get_id,
+	.get_id		= ext4_get_quotid,
 	.write_dquot	= ext4_write_dquot,
 	.acquire_dquot	= ext4_acquire_dquot,
 	.release_dquot	= ext4_release_dquot,
@@ -1092,6 +1098,7 @@ enum {
 	Opt_abort, Opt_data_journal, Opt_data_ordered, Opt_data_writeback,
 	Opt_data_err_abort, Opt_data_err_ignore,
 	Opt_usrjquota, Opt_grpjquota, Opt_offusrjquota, Opt_offgrpjquota,
+	Opt_trquota, Opt_trjquota, Opt_offtrjquota,
 	Opt_jqfmt_vfsold, Opt_jqfmt_vfsv0, Opt_quota, Opt_noquota,
 	Opt_ignore, Opt_barrier, Opt_nobarrier, Opt_err, Opt_resize,
 	Opt_usrquota, Opt_grpquota, Opt_i_version,
@@ -1143,9 +1150,12 @@ static const match_table_t tokens = {
 	{Opt_usrjquota, "usrjquota=%s"},
 	{Opt_offgrpjquota, "grpjquota="},
 	{Opt_grpjquota, "grpjquota=%s"},
+	{Opt_offtrjquota, "trjquota="},
+	{Opt_trjquota, "trjquota=%s"},
 	{Opt_jqfmt_vfsold, "jqfmt=vfsold"},
 	{Opt_jqfmt_vfsv0, "jqfmt=vfsv0"},
 	{Opt_grpquota, "grpquota"},
+	{Opt_trquota, "trquota"},
 	{Opt_noquota, "noquota"},
 	{Opt_quota, "quota"},
 	{Opt_usrquota, "usrquota"},
@@ -1450,6 +1460,10 @@ static int parse_options(char *options, struct super_block *sb,
 			if (!set_qf_name(sb, GRPQUOTA, &args[0]))
 				return 0;
 			break;
+		case Opt_trjquota:
+			if (!set_qf_name(sb, TRQUOTA, &args[0]))
+ 				return 0;
+ 			break;
 		case Opt_offusrjquota:
 			if (!clear_qf_name(sb, USRQUOTA))
 				return 0;
@@ -1458,6 +1472,10 @@ static int parse_options(char *options, struct super_block *sb,
 			if (!clear_qf_name(sb, GRPQUOTA))
 				return 0;
 			break;
+		case Opt_offtrjquota:
+			if (!clear_qf_name(sb, TRQUOTA))
+				return 0;
+			break;
 
 		case Opt_jqfmt_vfsold:
 			qfmt = QFMT_VFS_OLD;
@@ -1483,6 +1501,10 @@ set_qf_format:
 			set_opt(sbi->s_mount_opt, QUOTA);
 			set_opt(sbi->s_mount_opt, GRPQUOTA);
 			break;
+		case Opt_trquota:
+			set_opt(sbi->s_mount_opt, QUOTA);
+			set_opt(sbi->s_mount_opt, TRQUOTA);
+			break;
 		case Opt_noquota:
 			if (sb_any_quota_loaded(sb)) {
 				ext4_msg(sb, KERN_ERR, "Cannot change quota "
@@ -1492,18 +1514,22 @@ set_qf_format:
 			clear_opt(sbi->s_mount_opt, QUOTA);
 			clear_opt(sbi->s_mount_opt, USRQUOTA);
 			clear_opt(sbi->s_mount_opt, GRPQUOTA);
+			clear_opt(sbi->s_mount_opt, TRQUOTA);
 			break;
 #else
 		case Opt_quota:
 		case Opt_usrquota:
 		case Opt_grpquota:
+		case Opt_trquota:
 			ext4_msg(sb, KERN_ERR,
 				"quota options not supported");
 			break;
 		case Opt_usrjquota:
 		case Opt_grpjquota:
+		case Opt_trjquota:
 		case Opt_offusrjquota:
 		case Opt_offgrpjquota:
+		case Opt_offjquota:
 		case Opt_jqfmt_vfsold:
 		case Opt_jqfmt_vfsv0:
 			ext4_msg(sb, KERN_ERR,
@@ -1632,15 +1658,30 @@ set_qf_format:
 		}
 	}
 #ifdef CONFIG_QUOTA
-	if (sbi->s_qf_names[USRQUOTA] || sbi->s_qf_names[GRPQUOTA]) {
+	if (test_opt(sb, TRQUOTA) && !test_opt(sb, TREEID)) {
+		if (!EXT4_HAS_INCOMPAT_FEATURE(sb,
+						EXT4_FEATURE_INCOMPAT_TREEID)){
+			ext4_msg(sb, KERN_ERR, "treeid option specified"
+				" with no directory treeid feature "
+				"enabled. run tune2fs");
+			return 0;
+		}
+		set_opt(sbi->s_mount_opt, TREEID);
+	}
+	if (sbi->s_qf_names[USRQUOTA] || sbi->s_qf_names[GRPQUOTA] ||
+		sbi->s_qf_names[TRQUOTA]) {
 		if (test_opt(sb, USRQUOTA) && sbi->s_qf_names[USRQUOTA])
 			clear_opt(sbi->s_mount_opt, USRQUOTA);
 
 		if (test_opt(sb, GRPQUOTA) && sbi->s_qf_names[GRPQUOTA])
 			clear_opt(sbi->s_mount_opt, GRPQUOTA);
 
+		if (test_opt(sb, TRQUOTA) && sbi->s_qf_names[GRPQUOTA])
+			clear_opt(sbi->s_mount_opt, TRQUOTA);
+
 		if (sbi->s_mount_opt & (EXT4_MOUNT_USRQUOTA |
-						EXT4_MOUNT_GRPQUOTA)) {
+						EXT4_MOUNT_GRPQUOTA |
+						EXT4_MOUNT_TRQUOTA)) {
 			ext4_msg(sb, KERN_ERR, "old and new quota "
 					"format mixing");
 			return 0;
@@ -3737,6 +3778,21 @@ static inline struct inode *dquot_to_inode(struct dquot *dquot)
 	return sb_dqopt(dquot->dq_sb)->files[dquot->dq_type];
 }
 
+static qid_t ext4_get_quotid(struct inode *inode, int type)
+{
+	switch (type) {
+	case USRQUOTA:
+		return inode->i_uid;
+	case GRPQUOTA:
+		return inode->i_gid;
+	case TRQUOTA:
+		BUG_ON(!test_opt(inode->i_sb, TRQUOTA) &&
+			!(EXT4_SB(inode->i_sb)->s_qf_names[TRQUOTA]));
+		return EXT4_I(inode)->i_tree_id;
+	default:
+		BUG();
+	}
+}
 static int ext4_write_dquot(struct dquot *dquot)
 {
 	int ret, err;
diff --git a/fs/quota/quota.c b/fs/quota/quota.c
index a957a72..280703c 100644
--- a/fs/quota/quota.c
+++ b/fs/quota/quota.c
@@ -83,6 +83,7 @@ static int generic_quotactl_valid(struct super_block *sb, int type, int cmd,
 	if (cmd == Q_GETQUOTA) {
 		if (((type == USRQUOTA && current_euid() != id) ||
 		     (type == GRPQUOTA && !in_egroup_p(id))) &&
+			//// FIXME: add directory tree quota related code
 		    !capable(CAP_SYS_ADMIN))
 			//// FIXME: Figure out in which container this task
 			//// belongs to. It is strange, but seems it is
